searchNodes=[{"ref":"Rihanna.html","title":"Rihanna","type":"module","doc":"The primary client interface for Rihanna. There are two ways to dispatch jobs with Rihanna: Using mod-fun-args which is a bit like RPC Using a module that implements Rihanna.Job and passing in one argument See the documentation for enqueue/1 and enqueue/2 for more details. Supervisor You must have started Rihanna.Supervisor otherwise you will see an error trying to enqueue or retry jobs. Database Connections Rihanna requires 1 + N database connections per node, where 1 connection is used for the external API of enqueuing/retrying jobs and N is the number of dispatchers. The default configuration is to run one dispatcher per node, so this will use 2 database connections. Notes on queueing Rihanna uses a FIFO job queue, so jobs will be processed roughly in the order that they are enqueued. However, because Rihanna is a concurrent job queue, it may have multiple workers processing jobs at the same time so there is no guarantee of any ordering in practice. Scheduling You can schedule jobs for deferred execution using schedule/2 and schedule/3. Jobs scheduled for later execution will run shortly after the due at date, but there is no guarantee on exactly when they will run."},{"ref":"Rihanna.html#delete/2","title":"Rihanna.delete/2","type":"function","doc":"Deletes a job by ID. ID can be passed as either integer or string."},{"ref":"Rihanna.html#delete_by/2","title":"Rihanna.delete_by/2","type":"function","doc":"Deletes all jobs that match either/or module or function. Example Deletes all jobs for Module.function Rihanna.delete_by(mod: Module, fun: :function) Deletes all jobs for the module Module Rihanna.delete_by(mod: Module) Deletes all jobs for the function function Rihanna.delete_by(fun: :function)"},{"ref":"Rihanna.html#enqueue/2","title":"Rihanna.enqueue/2","type":"function","doc":"Enqueues a job specified as a module and one argument. It is expected that the module implements the Rihanna.Job behaviour and defines a function Rihanna.Job.perform/1. The argument may be anything. See Rihanna.Job for more on how to implement your own jobs. You can enqueue a job like so: # Enqueue job for later execution and return immediately Rihanna.enqueue(MyApp.MyJob, [arg1, arg2])"},{"ref":"Rihanna.html#retry/2","title":"Rihanna.retry/2","type":"function","doc":"Retries a job by ID. ID can be passed as either integer or string. Note that this only works if the job has failed - if it has not yet run or is currently in progress, this function will do nothing."},{"ref":"Rihanna.html#schedule/2","title":"Rihanna.schedule/2","type":"function","doc":"Schedule a job specified as a simple mod-fun-args tuple to run later. Example Schedule at a DateTime: due_at = ~N[2018-07-01 12:00:00] |&gt; DateTime.from_naive!(&quot;Etc/UTC&quot;) Rihanna.schedule({IO, :puts, [&quot;Umbrella-ella-ella&quot;]}, at: due_at) Schedule in 5 minutes: Rihanna.schedule({IO, :puts, [&quot;Umbrella-ella-ella&quot;]}, in: :timer.minutes(5))"},{"ref":"Rihanna.html#schedule/3","title":"Rihanna.schedule/3","type":"function","doc":"Schedule a job specified as a module and one argument to run later. It is expected that the module implements the Rihanna.Job behaviour and defines a function Rihanna.Job.perform/1. The argument may be anything. See Rihanna.Job for more on how to implement your own jobs. Example Schedule at a DateTime: due_at = DateTime.from_naive!(~N[2018-07-01 12:00:00], &quot;Etc/UTC&quot;) Rihanna.schedule(MyApp.MyJob, [arg1, arg2], at: due_at) Schedule in 5 minutes: Rihanna.schedule(MyApp.MyJob, [arg1, arg2], in: :timer.minutes(5))"},{"ref":"Rihanna.html#t:connection/0","title":"Rihanna.connection/0","type":"type","doc":""},{"ref":"Rihanna.html#t:schedule_option/0","title":"Rihanna.schedule_option/0","type":"type","doc":""},{"ref":"Rihanna.html#t:schedule_options/0","title":"Rihanna.schedule_options/0","type":"type","doc":""},{"ref":"Rihanna.Config.html","title":"Rihanna.Config","type":"module","doc":"Global configuration for Rihanna. Sensible defaults have been chosen for you but if you want, you can optionally override any of these values in your local configuration. For example, to change the table name for jobs: config :rihanna, jobs_table_name: &quot;awesome_jobs&quot;"},{"ref":"Rihanna.Config.html#behaviour_only?/0","title":"Rihanna.Config.behaviour_only?/0","type":"function","doc":"Restricts Rihanna to only running jobs that conform to the Rihanna behaviour. Being able to call Rihanna with mod-fun-args is convenient but presets a very slight increase in attack surface area. Some people may want to turn this off, which you can do by setting this option to true. Example config :rihanna, behaviour_only: true"},{"ref":"Rihanna.Config.html#debug?/0","title":"Rihanna.Config.debug?/0","type":"function","doc":"Toggle debug logging. Rihanna logs nothing by default. By configuring Rihanna with debug: true and setting Logger&#39;s log level to :debug, you can get much more information about what it is doing during operation to troubleshoot issues. Example config :rihanna, debug: true"},{"ref":"Rihanna.Config.html#dispatcher_max_concurrency/0","title":"Rihanna.Config.dispatcher_max_concurrency/0","type":"function","doc":"The maximum number of simultaneously executing workers for a dispatcher. 50 is chosen as a sensible default. Tuning this might increase or decrease your throughput depending on a lot of factors including database churn and how many other dispatchers you are running. Example config :rihanna, dispatcher_max_concurrency: 25"},{"ref":"Rihanna.Config.html#dispatcher_poll_interval/0","title":"Rihanna.Config.dispatcher_poll_interval/0","type":"function","doc":"How often the dispatcher should poll the database for new jobs (in milliseconds). Default is 100. Note that that actual poll interval in practice will be close to but not exactly this number of milliseconds for two reasons: A small amount of processing time for dispatching jobs is not included and will be added to the poll interval. A small, random amount of jitter is added to prevent multiple dispatchers started simultaneously from hitting the database at the same time. Example config :rihanna, dispatcher_poll_interval: :timer.seconds(1)"},{"ref":"Rihanna.Config.html#jobs_table_name/0","title":"Rihanna.Config.jobs_table_name/0","type":"function","doc":"The table name to use for Rihanna jobs. config :rihanna, jobs_table_name: &quot;my_jobs&quot;"},{"ref":"Rihanna.Config.html#pg_advisory_lock_class_id/0","title":"Rihanna.Config.pg_advisory_lock_class_id/0","type":"function","doc":"Specify the classid to use for advisory locks. Details In Postgres, advisory locks are scoped to a classid. Here we use a random classid to prevent potential collisions with other users of the advisory locking system. In the unimaginably unlucky scenario that this conflicts with a lock classid that is already being used on your system, you can change the classid that Rihanna uses here. Example config :rihanna, pg_advisory_lock_class_id: 42"},{"ref":"Rihanna.Config.html#producer_postgres_connection/0","title":"Rihanna.Config.producer_postgres_connection/0","type":"function","doc":"Specifies the Postgres database connection to use when enqueuing, scheduling, and deleting jobs. When set the Rihanna.Supervisor will not start a dedicated Postgrex connection process for these operations. If you application uses Ecto you can re-use your Ecto Repo here. Examples # Use a user-started Postgres connection process # `:my_postgrex_connection` is a named process started with [`Postgrex.start_link/1`](https://hexdocs.pm/postgrex/0.15.1/Postgrex.html#start_link/1). config :rihanna, producer_postgres_connection: {Postgrex, :my_postgrex_connection} # Use an Ecto Repo config :rihanna, producer_postgres_connection: {Ecto, MyApp.Repo}"},{"ref":"Rihanna.Config.html#startup_delay/0","title":"Rihanna.Config.startup_delay/0","type":"function","doc":"Use a startup delay to avoid killing the supervisor if we can&#39;t connect to the database for some reason. Value is in milliseconds. Defaults to 0 for test env and 5000ms for other envs. Example config :rihanna, startup_delay: :timer.milliseconds(500)"},{"ref":"Rihanna.Job.html","title":"Rihanna.Job","type":"behaviour","doc":"A behaviour for Rihanna jobs. You must implement Rihanna.Job.perform/1 in your job, and it must return one of the following values: :ok {:ok, result} :error {:error, reason} You can define your job like the example below: defmodule MyApp.MyJob do @behaviour Rihanna.Job # NOTE: `perform/1` is a required callback. It takes exactly one argument. To # pass multiple arguments, wrap them in a list and destructure in the # function head as in this example def perform([arg1, arg2]) do success? = do_some_work(arg1, arg2) if success? do # job completed successfully :ok else # job execution failed {:error, :failed} end end end This behaviour allows you to tailor what you&#39;d like to happen after your job either fails, or raises an exception. You can define an after_error/2 method which will run before the job is placed on the failed job queue. If you don&#39;t define this callback, it will add it to the failed job queue without running anything. If you wish to re-enqueue a job to run at a different time, you can simply return {:reenqueue, due_at} where due_at is some DateTime timestamp. def after_error(failure_reason, args) do notify_someone(__MODULE__, failure_reason, args) end You can define a retry_at/3 callback function. Returning {:ok, due_at} will schedule the job to run again at that time. Returning :noop (the default) proceeds with normal job failure behavior. The value of attempts counts up from 0, to allow backing off due_at to be calculated. def retry_at(_failure_reason, _args, attempts) when attempts &lt; 3 do due_at = DateTime.add(DateTime.utc_now(), attempts * 5, :second) {:ok, due_at} end def retry_at(_failure_reason, _args, _attempts) do warn(&quot;Job failed after 3 attempts&quot;) :noop end You can define a priority/0 function which will be called if no priority is set when a job is enqueued. It should return a single integer. A priority of 1 will be the highest priority, with larger numbers being run after. If you don&#39;t define this callback it will default to a priority of 50, in an attempt to have it run at a lower priority. def priority(), do: 2"},{"ref":"Rihanna.Job.html#c:after_error/2","title":"Rihanna.Job.after_error/2","type":"callback","doc":""},{"ref":"Rihanna.Job.html#after_error/3","title":"Rihanna.Job.after_error/3","type":"function","doc":"Checks whether a job implemented the after_error callback and runs it if it does."},{"ref":"Rihanna.Job.html#delete/2","title":"Rihanna.Job.delete/2","type":"function","doc":""},{"ref":"Rihanna.Job.html#mark_reenqueued/3","title":"Rihanna.Job.mark_reenqueued/3","type":"function","doc":""},{"ref":"Rihanna.Job.html#mark_retried/3","title":"Rihanna.Job.mark_retried/3","type":"function","doc":"Update attempts and set due_at datetime"},{"ref":"Rihanna.Job.html#c:perform/1","title":"Rihanna.Job.perform/1","type":"callback","doc":""},{"ref":"Rihanna.Job.html#c:priority/0","title":"Rihanna.Job.priority/0","type":"callback","doc":""},{"ref":"Rihanna.Job.html#priority/1","title":"Rihanna.Job.priority/1","type":"function","doc":"Checks if a job implements priority callback and runs it. A lower value means a higher job priority. Has a default of 50, a very low priority, to prevent new jobs from running before higher priority jobs, when no priority is set."},{"ref":"Rihanna.Job.html#c:retry_at/3","title":"Rihanna.Job.retry_at/3","type":"callback","doc":""},{"ref":"Rihanna.Job.html#retry_at/4","title":"Rihanna.Job.retry_at/4","type":"function","doc":"Checks when a job should be retried at"},{"ref":"Rihanna.Job.html#table/0","title":"Rihanna.Job.table/0","type":"function","doc":"The name of the jobs table."},{"ref":"Rihanna.Job.html#t:arg/0","title":"Rihanna.Job.arg/0","type":"type","doc":""},{"ref":"Rihanna.Job.html#t:reason/0","title":"Rihanna.Job.reason/0","type":"type","doc":""},{"ref":"Rihanna.Job.html#t:result/0","title":"Rihanna.Job.result/0","type":"type","doc":""},{"ref":"Rihanna.Job.html#t:t/0","title":"Rihanna.Job.t/0","type":"type","doc":""},{"ref":"Rihanna.Migration.html","title":"Rihanna.Migration","type":"module","doc":"A set of tools for creating the Rihanna jobs table. Rihanna stores jobs in a table in your database. The default table name is &quot;rihanna_jobs&quot;. The name is configurable by either passing it as an argument to the functions below or setting :jobs_table_name in Rihanna&#39;s config. Using Ecto The easiest way to create the database is with Ecto. Run mix ecto.gen.migration create_rihanna_jobs and make your migration file look like this: defmodule MyApp.CreateRihannaJobs do use Rihanna.Migration end Now you can run mix ecto.migrate. Without Ecto Ecto is not required to run Rihanna. If you want to create the table yourself, without Ecto, take a look at either statements/0 or sql/0."},{"ref":"Rihanna.Migration.html#drop_statements/1","title":"Rihanna.Migration.drop_statements/1","type":"function","doc":"Returns a list of SQL statements that will drop the Rihanna jobs table if executed sequentially. By default it takes the name of the table from the application config. You may optionally supply a table name as an argument if you want to override this. Examples &gt; Rihanna.Migration.drop_statements [...] &gt; Rihanna.Migration.drop_statements(&quot;my_alternative_table_name&quot;) [...]"},{"ref":"Rihanna.Migration.html#sql/1","title":"Rihanna.Migration.sql/1","type":"function","doc":"Returns a string of semi-colon-terminated SQL statements that you can execute directly to create the Rihanna jobs table."},{"ref":"Rihanna.Migration.html#statements/1","title":"Rihanna.Migration.statements/1","type":"function","doc":"Returns a list of SQL statements that will create the Rihanna jobs table if executed sequentially. By default it takes the name of the table from the application config. You may optionally supply a table name as an argument if you want to override this. Examples &gt; Rihanna.Migration.statements [...] &gt; Rihanna.Migration.statements(&quot;my_alternative_table_name&quot;) [...]"},{"ref":"Rihanna.Migration.Upgrade.html","title":"Rihanna.Migration.Upgrade","type":"module","doc":"A set of tools for upgrading an existing Rihanna jobs table. Rihanna stores jobs in a table in your database. The default table name is &quot;rihanna_jobs&quot;. The name is configurable by either passing it as an argument to the functions below or setting :jobs_table_name in Rihanna&#39;s config. Using Ecto The easiest way to upgrade the database is with Ecto. Run mix ecto.gen.migration upgrade_rihanna_jobs and make your migration look like this: defmodule MyApp.UpgradeRihannaJobs do use Rihanna.Migration.Upgrade end Now you can run mix ecto.migrate. Without Ecto Ecto is not required to run Rihanna. If you want to upgrade the table yourself, without Ecto, take a look at either statements/0 or sql/0."},{"ref":"Rihanna.Migration.Upgrade.html#drop_statements/1","title":"Rihanna.Migration.Upgrade.drop_statements/1","type":"function","doc":"Returns a list of SQL statements that will rollback the upgrade of Rihanna jobs table if executed sequentially. By default it takes the name of the table from the application config. You may optionally supply a table name as an argument if you want to override this. Examples &gt; Rihanna.Migration.Upgrade.drop_statements [...] &gt; Rihanna.Migration.Upgrade.drop_statements(&quot;my_alternative_table_name&quot;) [...]"},{"ref":"Rihanna.Migration.Upgrade.html#sql/1","title":"Rihanna.Migration.Upgrade.sql/1","type":"function","doc":"Returns a string of semi-colon-terminated SQL statements that you can execute directly to upgrade the Rihanna jobs table."},{"ref":"Rihanna.Migration.Upgrade.html#statements/1","title":"Rihanna.Migration.Upgrade.statements/1","type":"function","doc":"Returns a list of SQL statements that will upgrade the Rihanna jobs table if executed sequentially. By default it takes the name of the table from the application config. You may optionally supply a table name as an argument if you want to override this. Examples &gt; Rihanna.Migration.Upgrade.statements [...] &gt; Rihanna.Migration.Upgrade.statements(&quot;my_alternative_table_name&quot;) [...]"},{"ref":"Rihanna.Supervisor.html","title":"Rihanna.Supervisor","type":"module","doc":"The main supervisor for Rihanna. Starts the Postgrex process necessary for enqueueing jobs, and also starts a dispatcher for processing them. Setup Add Rihanna.Supervisor to your supervision tree. By adding it to your supervision tree it will automatically start running jobs when your app boots. Rihanna requires a database configuration to be passed in under the postgrex key. This is passed through directly to Postgrex. If you are already using Ecto you can avoid duplicating your DB config by pulling this out of your existing Repo using My.Repo.config(). # NOTE: In Phoenix you would find this inside `lib/my_app/application.ex` children = [ {Rihanna.Supervisor, [name: Rihanna.Supervisor, postgrex: My.Repo.config()]} ]"},{"ref":"Rihanna.Supervisor.html#child_spec/1","title":"Rihanna.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Rihanna.Supervisor.html#start_link/2","title":"Rihanna.Supervisor.start_link/2","type":"function","doc":""},{"ref":"readme.html","title":"Rihanna","type":"extras","doc":"Rihanna Rihanna is a fast, reliable and easy-to-use Postgres-backed distributed job queue for Elixir. It was inspired by the brilliant Que library for Ruby and uses advisory locks for speed. You might consider using Rihanna if: You need durable asynchronous jobs that are guaranteed to run even if the BEAM is restarted You want ACID guarantees around your jobs so you can be 100% sure they will never be lost You want a beautiful web GUI that allows you to inspect, delete and retry failed jobs You want a simple queue that uses your existing Postgres database and doesn&#39;t require any additional services or dependencies You need to process up to 10,000 jobs per second (if you need more throughput than this you should probably consider a &quot;real&quot; messaging system like Kafka or ActiveMQ) You want to pass arbitrary Elixir/Erlang terms that may not be JSON-serializable such as tuples or structs as arguments"},{"ref":"readme.html#contents","title":"Rihanna - Contents","type":"extras","doc":"Requirements Usage Installation With Ecto Without Ecto Configuration Upgrading FAQs"},{"ref":"readme.html#requirements","title":"Rihanna - Requirements","type":"extras","doc":"Rihanna requires Elixir &gt;= 1.5 (OTP &gt;= 18.0) and Postgres &gt;= 9.5"},{"ref":"readme.html#usage","title":"Rihanna - Usage","type":"extras","doc":"There are two ways to use Rihanna. The simplest way is to pass a mod-fun-args tuple like so: # Enqueue job for later execution and return immediately Rihanna.enqueue({MyModule, :my_fun, [arg1, arg2]}) The second way is to implement the Rihanna.Job behaviour and define the perform/1 function. Implementing this behaviour allows you to define retry strategies, show custom error messages on failure etc. See the docs for more details. defmodule MyApp.MyJob do @behaviour Rihanna.Job # NOTE: `perform/1` is a required callback. It takes exactly one argument. To # pass multiple arguments, wrap them in a list and destructure in the # function head as in this example def perform([arg1, arg2]) do success? = do_some_work(arg1, arg2) if success? do # job completed successfully :ok else # job execution failed {:error, :failed} end end end Now you can enqueue your jobs like so: # Enqueue job for later execution and return immediately Rihanna.enqueue({MyApp.MyJob, [arg1, arg2]}, opts) Job scheduling You can schedule jobs for deferred execution using schedule/2 and schedule/3. Schedule at a DateTime: Rihanna.schedule( {IO, :puts, [&quot;Hello&quot;]}, at: DateTime.from_naive!(~N[2018-07-01 12:00:00], &quot;Etc/UTC&quot;) ) Schedule in one hour: Rihanna.schedule({IO, :puts, [&quot;Hello&quot;]}, in: :timer.hours(1)) Jobs scheduled for later execution will run after their scheduled date, but there is no guarantee they will run at exactly their due date as this will depend on your configured poll interval and what other jobs are being processed."},{"ref":"readme.html#installation","title":"Rihanna - Installation","type":"extras","doc":"With Ecto Step 1 - add the dependency Add rihanna to your list of dependencies in mix.exs: def deps do [ {:rihanna, &quot;~&gt; 1.3&quot;}, ] end Install with mix deps.get. Step 2 - migrate the database Add a migration to create your jobs table. Rihanna stores jobs in a table in your database. The default table name is &quot;rihanna_jobs&quot;. Run mix ecto.gen.migration create_rihanna_jobs and make your migration look like this: defmodule MyApp.CreateRihannaJobs do use Rihanna.Migration end Now you can run mix ecto.migrate. Step 3 - configure Rihanna to use your Ecto Repo When using Ecto Rihanna can reuse your Ecto Repo to enqueue and schedule jobs, rather than creating a new database connection for these actions. This will also make Rihanna use the Ecto sandbox in test so you can run tests that enqueue jobs asynchronously. Note Rihanna will still create a dedicated database connection outside of the Repo for the dispatcher to poll for new jobs. # config/config.exs config :rihanna, producer_postgres_connection: {Ecto, MyApp.Repo} # Use the name of your Repo here Step 4 - boot the supervisor Add Rihanna.Supervisor to your supervision tree Rihanna.Supervisor starts a job dispatcher and by adding it to your supervision tree it will automatically start running jobs when your app boots. Rihanna requires a database configuration to be passed in under the postgrex key. This is passed through directly to Postgrex. If you are already using Ecto you can avoid duplicating your DB config by pulling this out of your existing Repo using My.Repo.config(). # Elixir 1.6+ # NOTE: In Phoenix you would find this inside `lib/my_app/application.ex` children = [ {Rihanna.Supervisor, [postgrex: My.Repo.config()]} ] # Elixir 1.5 import Supervisor.Spec, warn: false children = [ supervisor(Rihanna.Supervisor, [[postgrex: My.Repo.config()]]) ] Without Ecto Step 1 - add the dependency Add rihanna to your list of dependencies in mix.exs: def deps do [ {:rihanna, &quot;&gt;= 0.0.0&quot;} ] end Install with mix deps.get. Note:Postgrex requires some JSON library. Jason is the default they suggest, but if you are using a different library, please configure Postgrex to use it. Read more details in the Postgrex docs. Step 2 - migrate the database Add a migration to create your jobs table. Rihanna stores jobs in a table in your database. The default table name is &quot;rihanna_jobs&quot;. To create the table yourself take a look at the docs for Rihanna.Migration. Step 3 - boot the supervisor Add Rihanna.Supervisor to your supervision tree Rihanna.Supervisor starts a job dispatcher and by adding it to your supervision tree it will automatically start running jobs when your app boots. Rihanna requires a database configuration to be passed in under the postgrex key. This is passed through directly to Postgrex. If you are already using Ecto you can avoid duplicating your DB config by pulling this out of your existing Repo using My.Repo.config(). # Elixir 1.6+ # NOTE: In Phoenix you would find this inside `lib/my_app/application.ex` children = [ {Rihanna.Supervisor, [name: Rihanna.Supervisor, postgrex: My.Repo.config()]} ] # Elixir 1.5 import Supervisor.Spec, warn: false children = [ supervisor(Rihanna.Supervisor, [[name: Rihanna.Supervisor, postgrex: My.Repo.config()]]) ]"},{"ref":"readme.html#configuration","title":"Rihanna - Configuration","type":"extras","doc":"Rihanna should work out of the box without any configuration. However, should you wish to tweak it, take a look at the documentation for Rihanna.Config."},{"ref":"readme.html#upgrading","title":"Rihanna - Upgrading","type":"extras","doc":"Please refer to the Changelog for details on when a database upgrade is required and how to migrate the Rihanna jobs table. If you&#39;re on Rihanna v2, please check your rihanna_jobs_locking_index and check due_at. If it does not have NULLS FIRST, you&#39;ll want to recreate this index: CREATE INDEX CONCURRENTLY rihanna_jobs_locking_index_fixed ON rihanna_jobs (priority ASC, due_at ASC NULLS FIRST, enqueued_at ASC, id ASC); DROP INDEX rihanna_jobs_locking_index; ALTER INDEX rihanna_jobs_locking_index_fixed RENAME TO rihanna_jobs_locking_index;"},{"ref":"readme.html#faqs","title":"Rihanna - FAQs","type":"extras","doc":"Q: What does the supervision tree look like/how does Rihanna work? Q: How many jobs can be processed concurrently? By default Rihanna processes a maximum of 50 jobs per dispatcher. This number is configurable, see the docs. Q. What guarantees does Rihanna provide? Rihanna guarantees at-least-once execution of jobs regardless of node failures, netsplits or even database restarts. Rihanna strives to never execute a job more than once, however, this may be unavoidable in certain failure scenarios such as a node losing its connection to the database a node dying during execution of a job For this reason jobs should be made idempotent where possible. Q: Are there any limits on job duration? No. Rihanna jobs run for as long as they need to. One thing to be aware of is that if you restart your application (e.g. because you deployed) then all running jobs on that node will be exited. For this reason it is probably sensible not to make your jobs take an extremely long time. Q: How many database connections does Rihanna hold open? Rihanna requires 1 + N database connections per node, where 1 connection is used for the external API of enqueuing/retrying jobs and N is the number of dispatchers. In the default configuration of one dispatcher per node, Rihanna will use 2 database connections per node. It is possible to reuse an existing Postgres connection (such as an Ecto Repo) for enqueuing etc, bringing the number of connections down to N where N is the number of dispatchers. See Rihanna.Config for more information. Q. How fast is Rihanna? Performance should be at least as good as Que. I have seen it do around 1.5k jobs per second on a mid-2016 Macbook Pro. Significantly higher throughputs are possible with a beefier database server. More detailed benchmarks to come. For now see: https://github.com/chanks/queue-shootout. Q. Does it support multiple queues? Not yet, but it will. Q. Does it support cron tasks/recurring jobs? Yes! To implement a recurring job have the job reschedule itself after completion and Postgres&#39; ACID guarantees will ensure that it continues running. You will need to enqueue the job manually the first time from the console. Q. Are there risks of arbitrary code execution with the MFA variant? Short answer: No. Long answer: In order to do anything the attacker first needs to have obtained write access to your production database. In most companies, internal and customer data is far more important than whatever code is executing so you&#39;re already effectively hosed at this point. By default you can call Rihanna with any mod-fun-args tuple. This does give a potential attacker a few more options than if they were restricted to simply calling the perform/1 function on an existing module with different arguments. If you really want to turn this behaviour off, you can set the behaviour_only config option to true. Q. Why Rihanna? Because she knows how to work, work, work, work, work."}]